{% extends 'dashboard/dashboard_content.html' %}

{% block title %}
    Set Question Pattern
{% endblock %}

{% block rightPane %}

    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="fa fa-plus-circle"></i>
                Question Pattern
            </h2>
            <div class="clearfix"></div>
        </div>

        <div class="x_content">
            <div class="row">
                <ul class="nav nav-tabs bar_tabs">
                    {% for course in courseList %}
                        {% if forloop.counter == 1 %}
                            <li {% if staffCoursePk == course.staff_course_instance.pk %}class="active" {% else %}
                                class="" {% endif %}>
                                <a aria-expanded="true"
                                   id={{ course.staff_course_instance.pk }}
                                           data-toggle="tab" name="courseTab"
                                   onmouseover="$(this).css('cursor', 'pointer')">
                                    {{ course.display_text }}

                                </a>
                            </li>
                        {% else %}
                            <li {% if staffCoursePk == course.staff_course_instance.pk %}class="active" {% else %}
                                class="" {% endif %}>
                                <a aria-expanded="false"
                                   id={{ course.staff_course_instance.pk }}
                                           data-toggle="tab" name="courseTab"
                                   onmouseover="$(this).css('cursor', 'pointer')">
                                    {{ course.display_text }}
                                </a>
                            </li>
                        {% endif %}
                    {% endfor %}
                </ul>
            </div>
        </div>

        <form id="dummyForm" method="POST">
            {% csrf_token %}
        </form>

        <form id="deleteForm" method="POST">
            {% csrf_token %}
        </form>


        <div id="wizard" class="form_wizard wizard_horizontal">
            <ul class="wizard_steps anchor">
                <li>
                    <a id="h1" class="selected" isdone="1" rel="1">
                        <span class="step_no">1</span>
                        <span class="step_descr">
                                              Step 1<br>
                                          </span>
                    </a>
                </li>
                <li>
                    <a id="h2" class="done" isdone="1" rel="2">
                        <span class="step_no">2</span>
                        <span class="step_descr">
                                              Step 2<br>

                                          </span>
                    </a>
                </li>
                <li>
                    <a id="h3" class="done" isdone="1" rel="3">
                        <span class="step_no">3</span>
                        <span class="step_descr">
                                              Step 3<br>
                                          </span>
                    </a>
                </li>
            </ul>


            <div class="" style="height: 288px;">
                <div id="step-1" class="content" style="display: block;">
                    <h2 class="StepTitle"></h2>
                    <br><br>
                    <div class="row">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="form-horizontal form-label-left">
                                <form id="FormOne">
                                    <div class="form-group">
                                        <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                            Unit Test
                                        </label>
                                        <div class="col-md-6 col-sm-6 col-xs-12">
                                            <select class="form-control" id="unitTestNumber"
                                                    required>
                                                <option value="" disabled selected>Choose Unit Test</option>
                                                <option value="1">UNIT TEST I</option>
                                                <option value="2">UNIT TEST II</option>
                                                <option value="3">UNIT TEST III</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div id="getQuestionsDiv" style="display: none">
                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                No. of Questions
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input class="form-control" type="number"
                                                       id="totalQuestions" min="1" max="20" required>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <button id="add" type="submit" class="btn1 btn-dark-green">Next
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                    <div id="alertField" align="center" style="display: none">
                                        <div class="alert alert-warning" role="alert" align="center">
                                            <h4 style="font-size: 18px"> You have already created the paper
                                                pattern </h4>

                                        </div>
                                        <button type="button" class="btn btn-primary btn-lg" data-toggle="modal"
                                                data-target="#myModal">
                                            View
                                        </button>
                                        <button type="button" class="btn btn-danger btn-lg" data-toggle="modal"
                                                data-target="#myModaldel">
                                            Delete
                                        </button>
                                    </div>
                                    <div class="modal fade" id="myModal" tabindex="-1"
                                         role="dialog"
                                         aria-labelledby="conformmodal" aria-hidden="true">
                                        <div class="modal-dialog modal-lg" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <button type="button" class="close" data-dismiss="modal"
                                                            aria-label="Close">
                                                        <span aria-hidden="true">&times;</span>
                                                    </button>
                                                    <h4 class="modal-title">View Pattern</h4>
                                                </div>
                                                <div class="row">
                                                    <div class="col-md-8 col-md-offset-2">
                                                        <div>
                                                            <table class="table table-hover">
                                                                <thead>
                                                                <tr>
                                                                    <th>S. No.</th>
                                                                    <th>Question Number</th>
                                                                    <th>CO Mapped</th>
                                                                    <th>Marks Alloted</th>
                                                                </tr>
                                                                </thead>
                                                                <tbody id="viewContentArea">

                                                                </tbody>
                                                            </table>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn1 btn1-default"
                                                            data-dismiss="modal">Close
                                                    </button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="modal fade" id="myModaldel" tabindex="-1"
                                         role="dialog"
                                         aria-labelledby="conformmodal" aria-hidden="true">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <button type="button" class="close" data-dismiss="modal"
                                                            aria-label="Close">
                                                        <span aria-hidden="true">&times;</span>
                                                    </button>
                                                    <h4 class="modal-title">Delete Confirmation</h4>
                                                </div>
                                                <div class="row">
                                                    <div class="col-md-8 col-md-offset-2">
                                                        <div>
                                                            <h4 style="font-size: 18px"><strong>Oh
                                                                snap!</strong> This will delete this pattern
                                                                <br><br>And this is unrecoverable process
                                                            </h4>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn1 btn1-default"
                                                            data-dismiss="modal">Close
                                                    </button>
                                                    <button id="deletePattern" type="button"
                                                            class="btn1 btn1-danger"
                                                            data-dismiss="modal">Confirm Delete
                                                    </button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="step-2" class="content" style="display: none;">
                    <br>
                    <h2 class="StepTitle" align="center">Enter the no. of Subdivision for each Question</h2>
                    <br><br>
                    <div class="row">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="form-horizontal form-label-left">
                                <form id="FormTwo">
                                    <div id="subDivision">

                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="step-3" class="content" style="display: none;">
                    <h2 class="StepTitle"></h2>
                    <br><br>
                    <div class="row">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="form-horizontal form-label-left">
                                <form id="FormThree" method="POST">
                                    <div id="coMarks">

                                    </div>
                                    <div class="modal fade" id="conformmodal" tabindex="-1"
                                         role="dialog"
                                         aria-labelledby="conformmodal" aria-hidden="true">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <button type="button" class="close" data-dismiss="modal"
                                                            aria-label="Close">
                                                        <span aria-hidden="true">&times;</span>
                                                    </button>
                                                    <h4 class="modal-title">Confirm Submission</h4>
                                                </div>
                                                <div class="row">
                                                    <div class="col-md-8 col-md-offset-2">
                                                        <div id="addconfirmdetails">

                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn1 btn1-default"
                                                            data-dismiss="modal">Close
                                                    </button>
                                                    <button id="submit" type="button" class="btn1 btn-dark-green"
                                                            data-dismiss="modal">Set Pattern
                                                    </button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <br>
        <br>
        <br>
        <br>
    </div>

    <script type="text/javascript">

        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        $('document').ready(function () {
            $('[name="courseTab"]').click(function () {

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('#dummyForm');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'staffCoursePk'});
                $hiddenInput.appendTo('#dummyForm');

                $('#dummyForm').submit();

            });
        });

    </script>

    <script type="text/javascript">

        $(document).on("change", '#unitTestNumber', function (e) {
            var unitTestNumber = $(this).val();

            if (unitTestNumber == null) {
                alert('Select Unit Test!');
                return;
            }

            $.ajax({
                type: "POST",
                data: {
                    unitTestNumber: unitTestNumber,
                    hiddenStaffCoursePk: '{{ staffCoursePk }}',
                    csrfmiddlewaretoken: getCookie('csrftoken')
                },
                url: '{% url 'setCoPattern' %}',

                success: function (data) {
                    if (data.avail == 'true') {
                        $('#alertField').show();
                        $('#getQuestionsDiv').hide();
                        counter = 1;
                        document.getElementById('viewContentArea').innerHTML = '';
                        $.each(data.list, function (key, val) {
                            document.getElementById('viewContentArea').innerHTML += '<tr>' +
                                '<td>' + counter++ + '</td>' +
                                '<td>' + val.questionNumber + '</td>' +
                                '<td>' + val.coMapped + '</td>' +
                                '<td>' + val.maximumMark + '</td>' +
                                '</tr>';
                        });
                    }
                    else {
                        $('#getQuestionsDiv').show();
                        $('#alertField').hide();
                        $('#totalQuestions').focus();
                    }
                }
            });
        });
    </script>


    <script type="text/javascript">


        function isNumberKey(evt) {
            var charCode = (evt.which) ? evt.which : evt.keyCode;
            if (charCode != 46 && charCode > 31
                && (charCode < 48 || charCode > 57))
                return false;

            return true;
        }


        $(document).on("submit", '#FormOne', function (e) {
            var totalQuestions = $('#totalQuestions').val();
            e.preventDefault();
            $('#add').hide();
            $('#totalQuestions').prop('disabled', true);

            $('#step-1').hide();
            $('#step-2').show();
            $('#h2').addClass('selected').removeClass('done');
            $('#h1').addClass('done').removeClass('selected');

            counter = 1;
            for (; counter <= parseInt(totalQuestions); counter++) {
                document.getElementById('subDivision').innerHTML += '' +
                    '<div class="form-group">' +
                    '<label class="control-label col-md-3 col-sm-3 col-xs-12">Question ' + counter + '</label>' +
                    '<div class="col-md-6 col-sm-6 col-xs-12">' +
                    '<input class="form-control" type="number" value="1" id="subQuestion' + counter + '" min="1" max="5" onkeypress="return isNumberKey(event)" required>' +
                    '</div>' +
                    '</div>';
            }

            document.getElementById('subDivision').innerHTML += '' +
                '<div class="form-group">' +
                '<label class="control-label col-md-3 col-sm-3 col-xs-12">' +
                '</label>' +
                '<div class="col-md-6 col-sm-6 col-xs-12">' +
                '<button id="proceed" type="submit" class="btn1 btn-dark-green">Proceed</button>' +
                '</div>' +
                '</div>';
        });


        $(document).on("submit", '#FormTwo', function (e) {
            var totalQuestions = $('#totalQuestions').val();
            e.preventDefault();
            $('#step-2').hide();
            $('#step-3').show();
            $('#h3').addClass('selected').removeClass('done');
            $('#h2').addClass('done').removeClass('selected');

            counter = 1;
            for (; counter <= parseInt(totalQuestions); counter++) {
                for (subcounter = 1; subcounter <= parseInt($('#subQuestion' + counter).val()); subcounter++) {
                    if (parseInt($('#subQuestion' + counter).val()) == '1') {
                        document.getElementById('coMarks').innerHTML += '' +
                            '<div class="form-group">' +
                            '<label class="control-label col-md-4 col-sm-4 col-xs-12">Question ' + counter + '</label>' +
                            '<div class="col-md-3 col-sm-3 col-xs-12">' +
                            '<input class="form-control" type="number" placeholder="CO Number" id="coMapped' + counter + '-' + subcounter + '" min="1" onkeypress="return isNumberKey(event)" required>' +
                            '</div>' +
                            '<div class="col-md-3 col-sm-3 col-xs-12">' +
                            '<input class="form-control" type="number" placeholder="Mark for the question" id="maximumMark' + counter + '-' + subcounter + '" min="1" step="0.5" required>' +
                            '</div>' +
                            '</div>';
                    }
                    else {
                        document.getElementById('coMarks').innerHTML += '' +
                            '<div class="form-group">' +
                            '<label class="control-label col-md-4 col-sm-4 col-xs-12">Question ' + counter + '-' + String.fromCharCode(96 + subcounter) + '</label>' +
                            '<div class="col-md-3 col-sm-3 col-xs-12">' +
                            '<input class="form-control" type="number" placeholder="CO Number" id="coMapped' + counter + '-' + subcounter + '" min="1" onkeypress="return isNumberKey(event)" required>' +
                            '</div>' +
                            '<div class="col-md-3 col-sm-3 col-xs-12">' +
                            '<input class="form-control" type="number" placeholder="Mark for the question" id="maximumMark' + counter + '-' + subcounter + '" min="1" step="0.5" required>' +
                            '</div>' +
                            '</div>';
                    }
                }
            }

            document.getElementById('coMarks').innerHTML += '' +
                '<div class="form-group">' +
                '<label class="control-label col-md-5 col-sm-5 col-xs-12">' +
                '</label>' +
                '<div class="col-md-6 col-sm-6 col-xs-12">' +
                '<button id="finish" type="submit" class="btn1 btn-dark-green">Finish</button>' +
                '</div>' +
                '</div>';

        });


        $(document).on("submit", '#FormThree', function (e) {
            var totalQuestions = $('#totalQuestions').val();
            var subject_total_marks = 50;
            e.preventDefault();
            //alert($('#mark1-1').val());
            total_marks = 0;
            counter = 1;
            for (; counter <= parseInt(totalQuestions); counter++) {
                for (subcounter = 1; subcounter <= parseInt($('#subQuestion' + counter).val()); subcounter++) {
                    total_marks += parseFloat($('#maximumMark' + counter + '-' + subcounter).val());
                }
            }
            //alert(total_marks);

            if (subject_total_marks <= total_marks) {
                document.getElementById('addconfirmdetails').innerHTML = '<h5>Total marks counted for CO\' s : <strong>' + total_marks + '</strong></h5>' +
                    '<br><h4>Do you confirm the pattern?</h4>';
                $('#submit').show();
                $('#conformmodal').modal();
            }
            else {
                document.getElementById('addconfirmdetails').innerHTML = '<h5>Total marks counted for CO\' s : <strong>' + total_marks + '</strong></h5>' +
                    '<br><h5>But you have to set a pattern for <strong>' + subject_total_marks + '</strong> marks</h5>';
                $('#submit').hide();
                $('#conformmodal').modal();
            }
        });


        $(document).on("click", '#submit', function (e) {
            var totalQuestions = $('#totalQuestions').val();

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: getCookie('csrftoken'),
                name: 'csrfmiddlewaretoken'
            });
            $hiddenInput.appendTo('#dummyForm');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: '{{ staffCoursePk }}',
                name: 'hiddenStaffCoursePkOnSet'
            });
            $hiddenInput.appendTo('#dummyForm');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: $('#unitTestNumber').val(),
                name: 'unitTestNumber'
            });
            $hiddenInput.appendTo('#dummyForm');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: totalQuestions,
                name: 'totalQuestions'
            });
            $hiddenInput.appendTo('#dummyForm');


            counter = 1;
            for (; counter <= parseInt(totalQuestions); counter++) {
                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: parseInt($('#subQuestion' + counter).val()),
                    name: 'subQuestion' + counter
                });
                $hiddenInput.appendTo('#dummyForm');

                for (subcounter = 1; subcounter <= parseInt($('#subQuestion' + counter).val()); subcounter++) {
                    var $hiddenInput = $('<input/>', {
                        type: 'hidden',
                        value: parseFloat($('#maximumMark' + counter + '-' + subcounter).val()),
                        name: 'maximumMark' + counter + '-' + subcounter
                    });
                    $hiddenInput.appendTo('#dummyForm');

                    var $hiddenInput = $('<input/>', {
                        type: 'hidden',
                        value: parseInt($('#coMapped' + counter + '-' + subcounter).val()),
                        name: 'coMapped' + counter + '-' + subcounter
                    });
                    $hiddenInput.appendTo('#dummyForm');
                }
            }

            $('#dummyForm').submit();
        });


        $(document).on("click", '#deletePattern', function (e) {
            var unitTestNumber = $('#unitTestNumber').val();

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: getCookie('csrftoken'),
                name: 'csrfmiddlewaretoken'
            });
            $hiddenInput.appendTo('#deleteForm');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: unitTestNumber,
                name: 'deleteUnitTest'
            });
            $hiddenInput.appendTo('#deleteForm');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: '{{ staffCoursePk }}',
                name: 'deleteStaffCoursePk'
            });
            $hiddenInput.appendTo('#deleteForm');

            $('#deleteForm').submit();
        });

    </script>

{% endblock %}